from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import File, Int, String

Framebot_Stat_V0_1_0 = CommandToolBuilder(tool="FrameBot_stat", base_command=["FrameBot", "stat"], inputs=[ToolInput(tag="in_seq_desc", input_type=File(optional=True), prefix="--seq-desc", doc=InputDocumentation(doc="the description of the reference seq, tab-delimited file or fasta")), ToolInput(tag="in_identity", input_type=Int(optional=True), prefix="--identity", doc=InputDocumentation(doc="the minimum protein identity, default is 0, range [0-100]")), ToolInput(tag="in_id_mapping", input_type=File(optional=True), prefix="--id-mapping", doc=InputDocumentation(doc="Id mapping file. Output from Dereplicator\n(http://fungene.cme.msu.edu/FunGenePipeline/derep/form.spr).")), ToolInput(tag="in_sample_mapping", input_type=File(optional=True), prefix="--sample-mapping", doc=InputDocumentation(doc="Sample mapping file. Output from Dereplicator\n(http://fungene.cme.msu.edu/FunGenePipeline/derep/form.spr).")), ToolInput(tag="in_stat_type", input_type=Int(optional=True), prefix="--stat-type", doc=InputDocumentation(doc="stat | hist | summary | matrix | subset\nstat ouptuts the # of seqs passed FrameBot, # of frameshifts for each sample\nhist outputs a nearest match refseq, description and # of seqs close to the refseq at\ndifferent identity% ranges\nsummary outputs a list of subject(refseq), description and  # of seqs close to the subject\nmatrix outputs the number of sequences to the nearest match. The format is similar to a\ndata matrix used for R analysis\nsubset outputs the number of sequences to the nearest match for only sequence IDs in sample\nmapping file\n")), ToolInput(tag="in_get_frame_bot_stat_main", input_type=String(), position=0, doc=InputDocumentation(doc="")), ToolInput(tag="in_frame_bot_alignment_file_or_dir", input_type=File(), position=1, doc=InputDocumentation(doc="")), ToolInput(tag="in_out_file", input_type=File(), position=2, doc=InputDocumentation(doc=""))], outputs=[ToolOutput(tag="out_id_mapping", output_type=File(optional=True), selector=InputSelector(input_to_select="in_id_mapping", type_hint=File()), doc=OutputDocumentation(doc="Id mapping file. Output from Dereplicator\n(http://fungene.cme.msu.edu/FunGenePipeline/derep/form.spr).")), ToolOutput(tag="out_sample_mapping", output_type=File(optional=True), selector=InputSelector(input_to_select="in_sample_mapping", type_hint=File()), doc=OutputDocumentation(doc="Sample mapping file. Output from Dereplicator\n(http://fungene.cme.msu.edu/FunGenePipeline/derep/form.spr).")), ToolOutput(tag="out_out_file", output_type=File(), selector=InputSelector(input_to_select="in_out_file", type_hint=File()), doc=OutputDocumentation(doc=""))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Framebot_Stat_V0_1_0().translate("wdl", allow_empty_container=True)

